; Frosty rel 0.01
; Created by Graechan
; from a tutorial thanks to K1TesseraEna http://www.gimpchat.com/viewtopic.php?f=23&t=6143
; Cold Sky background adapted from Tharice Demand script
; Comments directed to http://gimpchat.com or http://gimpscripts.com
;
; License: GPLv3
;    This program is free software: you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
;    GNU General Public License for more details.
;
;    To view a copy of the GNU General Public License
;    visit: http://www.gnu.org/licenses/gpl.html
;
;
; ------------
;| Change Log |
; ------------ 
; Rel 0.01 - Initial Release
(define (script-fu-frosty 
                                      text 
                                      font-in 
                                      font-size
                                      bkg-type 
                                      pattern
                                      bkg-color
									  gradient
									  letter-spacing
									  brush-space
                                      conserve                                      
									  )
  (let* (
         (offx 0)
		 (offy 0)
		 (img-width 100)
		 (img-height 100)
		 (image (car (gimp-image-new img-width img-height RGB)))         
         (border (/ font-size 4))
		 (font (if (> (string-length font-in) 0) font-in (car (gimp-context-get-font))))
         (size-layer (car (gimp-text-fontname image -1 0 0 text border TRUE font-size PIXELS font)))
         (final-width (car (gimp-drawable-width size-layer)))
         (final-height (car (gimp-drawable-height size-layer)))
         (text-layer 0)
         (width img-width)
         (height img-height)
		 (text-width 0)
		 (text-height 0)
		 (selection 0)
         (bkg-layer 0)
		 (img 0)
		 (layer 0)
		 (img-display 0)
		 (path 0)
		 
		 
         
         )
    (gimp-context-push)
	(gimp-context-set-foreground '(0 0 0))
	(gimp-context-set-background '(255 255 255))

;;;;Add the text layer for a temporary larger Image size
    (set! text-layer (car (gimp-text-fontname image -1 0 0 text (round (/ 350 4)) TRUE 350 PIXELS font)))
	(gimp-text-layer-set-justification text-layer 2)
	(gimp-text-layer-set-letter-spacing text-layer letter-spacing)
    (set! text-width (car (gimp-drawable-width text-layer)))
    (set! text-height (car (gimp-drawable-height text-layer)))    
    (gimp-image-remove-layer image size-layer)
    (gimp-image-resize-to-layers image)	

;;;;set the new Image size
	(if (> text-width img-width) (set! width text-width))           
   (if (> text-height img-height) (set! height text-height))

;;;;square up the Image if needed	
    ;(if (< height width) (set! height width))
	;(if (< width height) (set! width height))

;;;;resize the image	
	(gimp-image-resize image width height 0 0)

	;;;;centre the text layer	
    (set! offx (/ (- width text-width) 2))
    (set! offy (/ (- height text-height) 2))    
    (gimp-layer-set-offsets text-layer offx offy)


;;;;set the text layer    
    (gimp-selection-layer-alpha text-layer)
	(set! selection (car (gimp-selection-save image)))
	(gimp-drawable-fill text-layer TRANSPARENT-FILL)
	(gimp-layer-set-mode text-layer SCREEN-MODE)
	(gimp-selection-none image)    
           
;;;;resize the text-layer		
    (gimp-image-set-active-layer image text-layer)
	(gimp-layer-resize-to-image-size text-layer)    

;;;;create the brush
    (set! img (car (gimp-image-new 60 5 RGB)))
    (set! layer (car (gimp-layer-new img 60 5 RGBA-IMAGE "Brush" 100 NORMAL-MODE)))
    (gimp-image-add-layer img layer 0)
	(gimp-image-select-ellipse img 2 0 0 60 5)
	(gimp-context-set-foreground '(255 255 255))
	(gimp-context-set-background '(21 45 76))
	(gimp-edit-blend layer FG-BG-RGB-MODE NORMAL-MODE  GRADIENT-BILINEAR 100 0 REPEAT-NONE FALSE FALSE 3 0.2 TRUE (/ 60 2) (/ 5 2) 60 (/ 5 2))
	(gimp-displays-flush)
	(gimp-selection-none img)
	(set! path (string-append gimp-directory "/brushes/" "mybrush" (number->string img) ".gbr"))
	(file-gbr-save RUN-NONINTERACTIVE img layer path path brush-space "My Brush")
	(gimp-image-delete img)
	
;;;;stroke the text-layer
	(gimp-brushes-refresh)
    (gimp-context-set-brush "My Brush")
	(gimp-context-set-dynamics "Dynamics Random")
	(gimp-selection-load selection)
    (gimp-edit-stroke text-layer)
	(gimp-selection-none image)
	(gimp-brush-delete "My Brush")
    
;;;;Scale Image to it's original size;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;	
	(gimp-image-scale-full image final-width final-height 2)
	(set! width (car (gimp-image-width image)))
	(set! height (car (gimp-image-height image)))
	
;;;;create the background layer    
	(set! bkg-layer (car (gimp-layer-new image width height RGBA-IMAGE "Background" 100 NORMAL-MODE)))
    (gimp-image-add-layer image bkg-layer 1)
	(gimp-context-set-pattern pattern)
	(gimp-context-set-background bkg-color)
	(gimp-context-set-gradient gradient)
	(if (= bkg-type 0) (frosty-sky image bkg-layer 200 20 4 32 24 conserve))
	(if (= bkg-type 1) (gimp-drawable-fill bkg-layer PATTERN-FILL))		
    (if (= bkg-type 2) (gimp-drawable-fill bkg-layer BACKGROUND-FILL))	
    (if (= bkg-type 3) (gimp-edit-blend bkg-layer CUSTOM-MODE NORMAL-MODE  GRADIENT-LINEAR 100 0 REPEAT-NONE FALSE FALSE 3 0.2 TRUE 0 0 width height))	
	
	(if (= conserve FALSE) (begin 
	(set! text-layer (car (gimp-image-merge-down image text-layer EXPAND-AS-NECESSARY)))	
	(gimp-drawable-set-name text-layer text)))
	
	
	(gimp-context-pop)
	
    
    

    (gimp-display-new image)
    )
  ) 
(script-fu-register "script-fu-frosty"
  "Frosty..."
  "Will Create a 'Frosty' Text  over a Background"
  "Graechan"
  "Graechan - http://gimpchat.com"
  "Jan 2013"
  ""
  SF-TEXT       "Text"    "FROSTY"
  SF-FONT       "Font"               "JasmineUPC Bold"
  SF-ADJUSTMENT "Font size (pixels)" '(350 6 500 1 1 0 1)
  SF-OPTION "Background Type" '("Cold Sky" "Pattern" "Color" "Gradient")
  SF-PATTERN    "Pattern"            "Pink Marble"
  SF-COLOR      "Background color"         '(0 0 0)
  SF-GRADIENT   "Background Gradient" "Abstract 3"
  SF-ADJUSTMENT "Letter Spacing" '(0 -100 100 1 10 0 0)
  SF-ADJUSTMENT "Brush Spacing" '(45 1 100 1 5 0 0)
  SF-TOGGLE     "Keep the Layers"   FALSE
  
  )
(script-fu-menu-register "script-fu-frosty"
  "<Image>/Script-Fu/Logos"
  )

(define (frosty-sky image drawable smalls mediums bigs bglum bgcon conserve)
        
		(gimp-image-undo-group-start image)
        (gimp-context-push); Save the foreground & background colors
  
  (let* (            
      
	  (width (car (gimp-image-width image)))
	  (height (car (gimp-image-height image)))
	  (layer-one 0)
      (layer-two)
      (ii 0)
      (ns 0)
      (xs 0)
      (ys 0)
      (nm 0)
      (xm 0)
      (ym 0)
      (nb 0)
      (xb 0)
      (yb 0)
      (lum 0)
      (pixw (cons-array 3 'byte))
    )

    (srand (realtime))
    (aset pixw 0 255)
    (aset pixw 1 255)
    (aset pixw 2 255)

    
    (set! layer-one (car (gimp-layer-new image width height RGB-IMAGE "Bottom" 100 NORMAL-MODE)))
	(gimp-image-add-layer image layer-one -1)

    ; Set the fg to white, bg to black
    (gimp-palette-set-foreground '(255 255 255))
    (gimp-context-set-background '(0 0 0))
    (gimp-drawable-fill layer-one 1)  ;0 FG, 1 BG, 2 white

    ; generating small stars
    (while (< ns smalls)
      (set! ns (+ ns 1))
      (set! xs (rand width))
      (set! ys (rand height))
      (set! lum (+ (rand 160) 32))
      (aset pixw 0 (+ lum (rand 64)))
      (aset pixw 1 (+ lum (rand 64)))
      (aset pixw 2 (+ lum (rand 64)))
      (gimp-drawable-set-pixel layer-one xs ys 3 pixw)

      ; preparing the exit of the loop
      (set! ii (+ ii 1))
      (if (> ii 10000) (set! ns smalls))
    ) ; end of loop

    ; generating medium stars
    (set! ii 0)
    (while (< nm mediums)
      (set! nm (+ nm 1))
      (set! xm (rand (- width 1)))
      (set! ym (rand (- height 1)))
      (set! lum (+ (rand 96) 128))
      (aset pixw 0 (+ lum (rand 32)))
      (aset pixw 1 (+ lum (rand 32)))
      (aset pixw 2 (+ lum (rand 32)))
      (gimp-drawable-set-pixel layer-one xm ym 3 pixw)
      (gimp-drawable-set-pixel layer-one (+ xm 1) ym 3 pixw)
      (gimp-drawable-set-pixel layer-one xm (+ ym 1) 3 pixw)
      (gimp-drawable-set-pixel layer-one (+ xm 1) (+ ym 1) 3 pixw)

      ; preparing the exit of the loop
      (set! ii (+ ii 1))
      (if (> ii 10000) (set! nm mediums))
    ) ; end of loop

    ; generating big stars
    (set! ii 0)
    (while (< nb bigs)
      (set! nb (+ nb 1))
      (set! xb (rand (- width 2)))
      (set! yb (rand (- height 2)))
      (set! lum (+ (rand 64) 160))
      (aset pixw 0 (+ lum (rand 32)))
      (aset pixw 1 (+ lum (rand 32)))
      (aset pixw 2 (+ lum (rand 32)))
      (gimp-drawable-set-pixel layer-one xb yb 3 pixw)
      (gimp-drawable-set-pixel layer-one (+ xb 1) yb 3 pixw)
      (gimp-drawable-set-pixel layer-one (+ xb 2) yb 3 pixw)
      (gimp-drawable-set-pixel layer-one xb (+ yb 1) 3 pixw)
      (gimp-drawable-set-pixel layer-one (+ xb 1) (+ yb 1) 3 pixw)
      (gimp-drawable-set-pixel layer-one (+ xb 2) (+ yb 1) 3 pixw)
      (gimp-drawable-set-pixel layer-one xb (+ yb 2) 3 pixw)
      (gimp-drawable-set-pixel layer-one (+ xb 1) (+ yb 2) 3 pixw)
      (gimp-drawable-set-pixel layer-one (+ xb 2) (+ yb 2) 3 pixw)

      ; preparing the exit of the loop
      (set! ii (+ ii 1))
      (if (> ii 10000) (set! nb bigs))
    ) ; end of loop

    (define layer-two (car (gimp-layer-copy layer-one 1)))
    (gimp-image-add-layer image layer-two -1)
    (gimp-image-set-active-layer image layer-two)
    (plug-in-gauss-rle 1 image layer-two 3 1 1)
    (plug-in-normalize 1 image layer-two)
    (gimp-layer-set-mode layer-two SCREEN-MODE)
	 

    (define layer-three (car (gimp-layer-copy layer-one 1)))
    (gimp-image-add-layer image layer-three -1)
    (gimp-image-set-active-layer image layer-three)
    (plug-in-gauss-rle 1 image layer-three 6 1 1)
    (plug-in-normalize 1 image layer-three)
    (gimp-layer-set-mode layer-three SCREEN-MODE)

    (define layer-four (car (gimp-layer-copy layer-one 1)))
    (gimp-image-add-layer image layer-four -1)
    (gimp-image-set-active-layer image layer-four)
    (plug-in-gauss-rle 1 image layer-four 32 1 1)
    (gimp-levels layer-four 0 0 (- 44 bgcon) 1 0 255)
    (plug-in-gauss-rle 1 image layer-four 16 1 1)
    (gimp-colorize layer-four 236 64 bglum)
    (gimp-layer-set-mode layer-four SCREEN-MODE)

    (gimp-layer-set-name layer-one "Stars")
    (gimp-layer-set-name layer-two "Stars contour")
    (gimp-layer-set-name layer-three "Stars halo")
    (gimp-layer-set-name layer-four "Sky bg")
	
	(if (= conserve FALSE) (begin
	(set! layer-one (car (gimp-image-merge-down image layer-two EXPAND-AS-NECESSARY)))
	(set! layer-one (car (gimp-image-merge-down image layer-three EXPAND-AS-NECESSARY)))
	(set! layer-one (car (gimp-image-merge-down image layer-four EXPAND-AS-NECESSARY)))
	(set! drawable (car (gimp-image-merge-down image layer-one EXPAND-AS-NECESSARY)))))

	
	(gimp-displays-flush)
	(gimp-image-undo-group-end image)
    (gimp-context-pop); Restore the old foreground & background colors
    

    
  )
)
