; Pressed out Text rel 0.01
; Created by Graechan
; Comments directed to http://gimpchat.com or http://gimpscripts.com
;
; License: GPLv3
;    This program is free software: you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation, either version 3 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
;    GNU General Public License for more details.
;
;    To view a copy of the GNU General Public License
;    visit: http://www.gnu.org/licenses/gpl.html
;
;
; ------------
;| Change Log |
; ------------ 
; Rel 0.01 - Initial Release
(define (script-fu-pressed-out-text 
                                      text 
                                      font-in 
                                      font-size
                                      pattern
                                      color
									  )
  (let* (
         
         (offx 0)
         (offy 0)
         (image (car (gimp-image-new 50 50 RGB)))
         
         (border (/ font-size 4))
		 (font (if (> (string-length font-in) 0) font-in (car (gimp-context-get-font))))
         (text-layer (car (gimp-text-fontname image -1 0 0 text border TRUE font-size PIXELS font)))
         (width (car (gimp-drawable-width text-layer)))
         (height (car (gimp-drawable-height text-layer)))
         (bkg-layer 0)
		 
		 
         
         )
    (gimp-context-push)
	(gimp-context-set-foreground '(0 0 0))
	(gimp-context-set-background '(255 255 255))
	
;;;;centre text on line
	(gimp-text-layer-set-justification text-layer 2)

;;;;resize the image	
	(gimp-image-resize image width height 0 0)


;;;;set the text clolor    
    (gimp-context-set-pattern pattern)
	(gimp-selection-layer-alpha text-layer)
	(gimp-edit-fill text-layer PATTERN-FILL)
	(script-fu-drop-shadow image text-layer 4 4 15 '(0 0 0) 80 FALSE)
    (gimp-selection-shrink image 3)
	(gimp-context-set-foreground color)
	(gimp-edit-fill text-layer FOREGROUND-FILL)
	(gimp-selection-invert image)
	(script-fu-drop-shadow image text-layer 8 8 15 '(0 0 0) 80 FALSE)
	(gimp-selection-none image)
	
;;;;create the background layer    
	(set! bkg-layer (car (gimp-layer-new image width height RGBA-IMAGE "Background" 100 NORMAL-MODE)))
    (gimp-image-add-layer image bkg-layer 3)
	(gimp-context-set-pattern pattern)
	(gimp-drawable-fill bkg-layer PATTERN-FILL)		
    
;;;;merge all the layers
    (set! text-layer (car (gimp-image-flatten image)))              

	(gimp-context-set-gradient "FG to Transparent")
	(gimp-context-set-foreground '(0 0 0))
;	(gimp-edit-blend text-layer CUSTOM-MODE NORMAL-MODE GRADIENT-RADIAL 100 0 REPEAT-NONE TRUE FALSE 3 0.2 TRUE (/ width 2) (/ height 2) width height)
	(plug-in-lighting 1 
	    image              ; IMAGE
		text-layer         ; DRAWABLE
		text-layer         ; BUMP MAP  (set to 0 if disabled)
		0                  ; ENVIRONMENT MAP  (set to 0 if disabled)
		TRUE               ; ENABLE BUMPMAPPING
		FALSE              ; ENABLE ENVMAPPING
		0                  ; TYPE OF MAPPING (0=linear,1=log, 2=sinusoidal, 3=spherical)
		0                  ; TYPE OF LIGHTSOURCE (0=point,1=directional,3=spot,4=none) 
		'(255 255 255)     ; LIGHTSOURCE COLOR
		-1                 ; LIGHTSOURCE POS X
		-1                 ; LIGHTSOURCE POS Y
		1                  ; LIGHTSOURCE POS Z
		-1                 ; LIGHTSOURCE DIR X
		-1                 ; LIGHTSOURCE DIR Y
		1                  ; LIGHTSOURCE DIR Z
		0.20               ; AMBIANT INTENSITY (GLOWING)
		0.50               ; DIFFUSE INTENSITY (BRIGHT)
		1                  ; DIFFUSE REFLECTIVITY (INTENSITY)
		0.50               ; SPECULAR REFLECTIVITY (SHINY)
		27                 ; HIGHLIGHT (POLISHED)
		TRUE               ; ANTIALIASING
		FALSE              ; CREATE NEW IMAGE
		FALSE)	           ; MAKE BACKGROUND TRANSPARENT
	
	(gimp-edit-blend text-layer CUSTOM-MODE NORMAL-MODE GRADIENT-RADIAL 100 0 REPEAT-NONE TRUE FALSE 3 0.2 TRUE (/ width 2) (/ height 2) (+ width border) (+ height border))

	(gimp-context-pop)

    (gimp-display-new image)
    )
  ) 
(script-fu-register "script-fu-pressed-out-text"
  "Pressed out Text"
  "Create an image with a text layer over a pattern layer"
  "Graechan"
  "Graechan - http://gimpchat.com"
  "June 2012"
  ""
  SF-TEXT       "Text"    "GIMP"
  SF-FONT       "Font"               "Sans Bold"
  SF-ADJUSTMENT "Font size (pixels)" '(150 6 500 1 1 0 1)
  SF-PATTERN    "Pattern"            "Pine?"
  SF-COLOR      "Tint Color"         '(106 106 106)
  )
(script-fu-menu-register "script-fu-pressed-out-text"
  "<Image>/Script-Fu/Logos"
  )